initialize() {
	initializeSLiMOptions(preventIncidentalSelfing=T);
	
	if (exists("slimgui"))
	{
		defineConstant("seed", 0);
		defineConstant("population_size", "400");
		defineConstant("death_rate", "0.3");
		defineConstant("selection_coefficient", "0.01");
		defineConstant("generations_to_simulate", "1000");
		defineConstant("initial_allele_proportion", "0.5");
		defineConstant("output_file", "~/Desktop/slim_log.txt");
	
	}
	
	// Constants that are not important for now and will not be controlled by the command line
	setSeed(seed);
	defineConstant("mu", 0);
	defineConstant("r", 0);
	defineConstant("L", 3);  // Simulated locus length; will add the allele at pos 1
	defineConstant("initialSexRatio", 0.5);
	
	
	// Parse constants given by the command line
	defineConstant("N", asInteger(population_size));
	defineConstant("survival", 1 - asFloat(death_rate));
	defineConstant("s", asFloat(selection_coefficient));
	defineConstant("max_gen", asInteger(generations_to_simulate));
	defineConstant("m1_init_ratio", asFloat(initial_allele_proportion));
	
	
	// initialize chromosome model
	initializeMutationRate(mu);
	// dominance set to 1 as a reminder, that we transmit haploid
	initializeMutationType("m1", 1.0, "f", s);
	m1.convertToSubstitution = F;
	initializeGenomicElementType("g1", m1, 1.0);
	initializeGenomicElement(g1, 0, L-1);
	initializeRecombinationRate(r);
	initializeSex("A");
	
	
	// initialize output file
	if (!exists("slimgui"))
		writeFile(output_file, paste(c("seed", "selcoeff", "generation", "popsize", "sexratio", "hasmut_m", "hasmut_f", "nomut_m", "nomut_f"), sep="\t"), append = F);
}


// create population
1 early() {
	if (exists("slimgui"))
	{
		log = sim.createLogFile(output_file, sep="\t", logInterval=1);
		log.addCustomColumn("seed", "getSeed();");
		log.addGeneration();
		log.addPopulationSize();
		log.addPopulationSexRatio();
		log.addCustomColumn("hasmut_m", 'count_individuals(p1.individuals, sex="M", hasmut=T);');  // males that have the mutation
		log.addCustomColumn("hasmut_f", 'count_individuals(p1.individuals, sex="F", hasmut=T);');  // females that have the mutation
		log.addCustomColumn("nomut_m", 'count_individuals(p1.individuals, sex="M", hasmut=F);');  // males that do not have the mutation
		log.addCustomColumn("nomut_f", 'count_individuals(p1.individuals, sex="F", hasmut=F);');  // females that do not have the mutation
	}
	
	
	// initializing
	sim.addSubpop("p1", N, initialSexRatio);
	sim.rescheduleScriptBlock(s1, max_gen, max_gen);  // to finish simulation
	
	
	// add initial mutations to genome 1 (haploid)
	inds = p1.individuals;
	target = sample(inds, asInteger(m1_init_ratio * size(inds))).genome1;
	target.addNewDrawnMutation(m1, 1);
}


// log the results
1: late() {
	if (!exists("slimgui"))
	{
		contents = paste(c(
			getSeed(),
			selection_coefficient,
			sim.generation,
			p1.individualCount,
			p1.sexRatio,
			count_individuals(p1.individuals, sex="M", hasmut=T),
			count_individuals(p1.individuals, sex="F", hasmut=T),
			count_individuals(p1.individuals, sex="M", hasmut=F),
			count_individuals(p1.individuals, sex="F", hasmut=F)
			), sep="\t");
		writeFile(filePath=output_file, contents=contents, append = T);
	}
}


// modify child
modifyChild() {
	// allow only inheritance by males	
	/*
		childGenome1 is from the first parent (parent1 is always female)
		childGenome2 is from the second parent (parent2 is always male)
		
		Because we cannot use cloning, we need to make sure, that only the parent genome1
		is transmitted
	*/
	childGenome1.removeMutations();
	childGenome2.removeMutations();
	
	// inherit only if mutation is there in female parent
	if (parent1Genome1.countOfMutationsOfType(m1)==1) {
		childGenome1.addMutations(parent1Genome1.mutations);
	}
	
	
	// add death rate
	will_survive = runif(1) >= death_rate;
	if (!will_survive)
		child.fitnessScaling = 0;
	
	return T;
}


// function for the logfile
function (integer)count_individuals(o inds, string sex, logical hasmut)
{
	
	target = inds[inds.sex == sex].genome1.countOfMutationsOfType(m1);
	if (hasmut)
		counted_inds = sum(target == 1);
	else if (!hasmut)
		counted_inds = sum(target == 0);
	else
		stop("there is an error in the count_individuals() function call");
	
	return counted_inds;
}




// finish simulation if fixed
1: late() {
	freqs = 2 * sim.mutationFrequencies(p1); // *2 because haploid
	if (size(freqs) > 1) {
		print(freqs);
		stop("more than one mutation, this should not happen");
	}
	
	if (size(freqs) == 0) {
		catn("mutation has been lost");
		sim.simulationFinished();
	} else if (freqs == 1) {
		catn("mutation has been fixed");
		sim.simulationFinished();
	}
}


// finish simulation if max generation is reached
s1 100 {
	sim.simulationFinished();
}

